<template>
  <div class="auth-wrapper">
    <!-- edit form for items -->
    <form class="auth-inner" @submit.prevent="handleSubmit">
      <h3>Update item {{selectedItem.item_id}}</h3>
      <div class="form-group">
        <label>ID: </label>
        <input type="text" class="form-control" v-model="slug" :placeholder="selectedItem.slug" required/>
      </div>
      <div class="form-group">
        <label>Item: </label>
        <input type="text" class="form-control" v-model="itemName" :placeholder="selectedItem.itemName" required/>
      </div>
      <div class="form-group">
        <label>Description: </label>
        <textarea class="form-control" v-model="body" :placeholder="selectedItem.body" required/>
      </div>
      <div class="form-group">
        <label>Category: </label>
        <input type="text" class="form-control" v-model="category" :placeholder="selectedItem.category" required/>
      </div>
      <!-- custom column only appears if the inventory has a custom column -->
      <div class="form-group" v-if="selectedInventory.customColumnOne">
        <label>{{selectedInventory.customColumnOne}}: </label>
        <input type="text" class="form-control" v-model="customColumnOneData" :placeholder="selectedItem.customColumnOneData"/>
      </div>
      <!-- custom column 2 only appears if the inventory has a custom column 2 -->
      <div class="form-group" v-if="selectedInventory.customColumnTwo">
        <label>{{selectedInventory.customColumnTwo}}: </label>
        <input type="text" class="form-control" v-model="customColumnTwoData" :placeholder="selectedItem.customColumnTwoData"/>
      </div>
      <div class="form-group">
        <label>Stock: </label>
        <input type="Number" class="form-control" v-model="stockLevel" :placeholder="selectedItem.stockLevel" required/>
      </div>
      <button class="btn btn-success btn-block" @click="handleSubmit">Done</button>
    </form>
  </div>
</template>

<script>
// Importing axios to make requests to the backend.
import axios from 'axios'
export default {
  name: 'updateItem',
  props: ['selectedItem', 'selectedInventory'],
  data () {
    return {
      baseURL: 'http://localhost:8000/api/',
      slug: '',
      itemName: '',
      body: '',
      category: '',
      stockLevel: Number,
      customColumnOneData: '',
      customColumnTwoData: ''
    }
  },
  methods: {
    // submit method for the item edit form
    async handleSubmit () {
      const response = await axios.put(this.baseURL + 'items', {
        inventory_id: this.selectedInventory.inventory_id,
        item_id: this.selectedItem.item_id,
        slug: this.slug,
        itemName: this.itemName,
        body: this.body,
        category: this.category,
        stockLevel: this.stockLevel,
        customColumnOneData: this.customColumnOneData,
        customColumnTwoData: this.customColumnTwoData
      })
      console.log(response)
      this.$router.go(-1)
    }
  }
}
</script>
